#define PIN_MISO (32+0) 
#define PIN_CLK (32+5)
#define PIN_MOSI (32+4)
#define PIN_SS  (32+3)

#include <sys/types.h>
#include <stdio.h>
#include <sys/time.h>
#include <fcntl.h>
#include <string.h>
#include <propeller.h>
#include <sys/vfs.h>

void dodir(void);

char Buffer[512];
struct tm tv;
vfs_t *fs;


int main(int argc, char** argv)
{
    uint32_t w;
    int i;
    int fd;
    time_t t;
    struct timeval x;

    tv.tm_year = 2022 - 1900;
    tv.tm_mon = 2;
    tv.tm_mday = 7;
    tv.tm_hour = 6;
    tv.tm_min = 0;
    tv.tm_sec = 0;
    t = mktime(&tv);
    x.tv_sec = t;
    x.tv_usec = 0;

    settimeofday(&x, 0);

    _setbaud(115200);
    printf("Mounting...\n");
    _waitMs(1000);
    _pinl(39);  // enable SD power

    //fs = _vfs_open_sdcardx(PIN_CLK, PIN_SS, PIN_MOSI, PIN_MISO);
    //fs = _vfs_open_sdcardx(61, 60, 59, 58);
    fs = _vfs_open_sdcardx(41, 43, 42, 40);
    //fs = _vfs_open_sdcardx(45, 43, 44, 40);
    //fs = _vfs_open_sdcardx(37, 35, 36, 32);
    
    //fs = _vfs_open_sdm(0, PIN_SS, PIN_CLK, PIN_MOSI, PIN_MISO);
    i = mount("/sd", fs);

    if (i != 0)
    {
        printf("mount failed\n");
        while (1)
            _waitms(1000);
    }

    dodir();

    while(1); // don't go on yet
    printf("Opening file test.html\n");

    fd = open("/sd/OneCall.txt", O_RDONLY, 0);
    if (fd < 0)
    {
        printf("File Not Found!\n");
        while (1)
            _waitms(1000);
    }

    i = read(fd, Buffer, 256);

    Buffer[i] = 0;
    printf("Buffer: %s\n", Buffer);

    close(fd);

    printf("Writing log file\n");

    fd = open("/sd/logfile.txt", O_WRONLY | O_CREAT | O_APPEND, 644);
    if (fd < 0)
    {
        printf("File Creation Error!\n");
        while (1)
            _waitms(1000);
    }

    i =  write(fd, "Test Data only y\n", 18);

    printf("Wrote %d\n", i);

    close(fd);

    printf("Done\n");


    while (1)
    {
        _waitms(1000);
    }
}

void dodir()
{
    DIR *dir;
    struct dirent *ent;

    dir = opendir("/sd/");

    if (dir == NULL)
    {
        printf("Directory Failed!(%d)\n", errno);
        while (1)
            _waitms(1000);
    }

    printf("Mounted..\n");

    while (ent = readdir(dir))
    {
#if 0
        tv.tm_year = (ent->d_date >> 9) + 80;
        tv.tm_mon = ((ent->d_date >> 5) & 0x0f) - 1;
        tv.tm_mday = (ent->d_date) & 0x01f;
        tv.tm_hour = (ent->d_time >> 11);
        tv.tm_min = (ent->d_time >> 5) & 0x3f;
        tv.tm_sec = (ent->d_time) & 0x1f;
#endif

        if (ent->d_type == DT_DIR) //& ATTR_DIRECTORY)
            printf("d  ");
        else
            printf("   ");

        printf("%s %d %s", ent->d_name, ent->d_size, asctime(&tv));
    }

    closedir(dir);

    printf("\n");
}
